using System;
using Foxit.PDF;
using Foxit.PDF.Merger;
using Foxit.PDF.PageElements;

namespace Web_CSharp.MergerExamples
{
	public partial class FormFill : System.Web.UI.Page
	{

		protected void Page_Load(object sender, System.EventArgs e)
		{
			if( this.IsPostBack )
			{
                // Create a MergeOptions object to import the AcroForm
                MergeOptions options = new MergeOptions(false);

                // Create a document and set it's properties
                MergeDocument document = new MergeDocument(MapPath("../PDFs/fw9_11.pdf"), options);
                document.Creator = "FormFill.aspx";
				document.Author = "Foxit Software";
				document.Title = "W-9 Form Filler";

				// Get the imorted page and set margins.
				Foxit.PDF.Page page = document.Pages[0];
				page.Dimensions.SetMargins( 41, 35, 45, 37 );

				// Uncomment the line below to show a layout grid.
				//page.Elements.Add( new LayoutGrid() );

                // Add page elements to the page
                page.Elements.Add(new Label(txtName.Text, 20, 60, 490, 12, Font.Courier, 9));
                page.Elements.Add(new Label(txtBusinessName.Text, 20, 84, 490, 12, Font.Courier, 9));

                switch (chkBusinessType.SelectedItem.Value)
                {
                    case "1":
                        page.Elements.Add(new Label("3", 25, 112, 20, 12, Font.ZapfDingbats, 6));
                        break;
                    case "2":
                        page.Elements.Add(new Label("3", 133, 112, 20, 12, Font.ZapfDingbats, 6));
                        break;
                    case "3":
                        page.Elements.Add(new Label("3", 205, 112, 20, 12, Font.ZapfDingbats, 6));
                        break;
                    case "4":
                        page.Elements.Add(new Label("3", 277, 112, 20, 12, Font.ZapfDingbats, 6));
                        break;
                    case "5":
                        page.Elements.Add(new Label("3", 335, 112, 20, 12, Font.ZapfDingbats, 6));
                        break;
                    case "6":
                        page.Elements.Add(new Label("3", 26, 136, 50, 12, Font.ZapfDingbats, 6));
                        page.Elements.Add(new Label(txtTaxClassification.Text, 375, 134, 160, 12, Font.Courier, 9));
                        break;
                    case "7":
                        page.Elements.Add(new Label("3", 26, 160, 50, 12, Font.ZapfDingbats, 6));
                        page.Elements.Add(new Label(txtBusinessTypeOther.Text, 130, 158, 160, 12, Font.Courier, 9));
                        break;
                }

                if (chkExempt.Checked)
                {
                    page.Elements.Add(new Label("3", 474, 130, 50, 12, Font.ZapfDingbats, 6));
                }

                page.Elements.Add(new Label(txtAddress.Text, 20, 180, 300, 12, Font.Courier, 9));
                page.Elements.Add(new Label(txtAddress2.Text, 20, 204, 300, 12, Font.Courier, 9));
                page.Elements.Add(new Label(txtRequestersAddress.Text, 350, 180, 170, 36, Font.Courier, 9));
                page.Elements.Add(new Label(txtAccounts.Text, 20, 228, 160, 12, Font.Courier, 9));

                string ssn = txtSSN.Text.Trim().Replace("-", "").Replace(" ", "");
                string ein = txtEIN.Text.Trim().Replace("-", "").Replace(" ", "");
                if (ssn.Length >= 9)
                {
                    page.Elements.Add(new Label(ssn.Substring(0, 1), 375, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(1, 1), 391.4f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(2, 1), 405.8f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(3, 1), 433.2f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(4, 1), 447.6f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(5, 1), 475.4f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(6, 1), 490.8f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(7, 1), 505.2f, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ssn.Substring(8, 1), 520, 272, 14, 12, Font.Courier, 9, TextAlign.Center));
                }
                else if (ein.Length >= 9)
                {
                    page.Elements.Add(new Label(ein.Substring(0, 1), 376, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(1, 1), 391.4f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(2, 1), 418.8f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(3, 1), 433.2f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(4, 1), 447.6f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(5, 1), 462, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(6, 1), 476.4f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(7, 1), 490.8f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                    page.Elements.Add(new Label(ein.Substring(8, 1), 505.2f, 320, 14, 12, Font.Courier, 9, TextAlign.Center));
                }

				// Outputs the W-9 to the current web page
				document.DrawToWeb( "FormFiller.pdf" );
				Visible = false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
	}
}
